//+------------------------------------------------------------------+
//|                                             DevolatileVisual.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, TheXpert"
#property link      "theforexpert@gmail.com"

#property indicator_separate_window

#property indicator_buffers 6

#property indicator_color1 LightSteelBlue
#property indicator_color2 SteelBlue
#property indicator_color3 Black
#property indicator_color4 LightSteelBlue
#property indicator_color5 SteelBlue
#property indicator_color6 Black

#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 5

double BodyUp[];
double BodyDown[];
double MaskBody[];
double ShadeUp[];
double ShadeDown[];
double MaskShade[];

extern int     ATRPeriod      = 14;
extern int     SmoothPeriod   = 20;
extern double  coef           = 1000;

int init()
{
   SetIndexBuffer(0, BodyUp);
   SetIndexBuffer(1, BodyDown);
   SetIndexBuffer(2, MaskBody);
   SetIndexBuffer(3, ShadeUp);
   SetIndexBuffer(4, ShadeDown);
   SetIndexBuffer(5, MaskShade);

   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexStyle(4, DRAW_HISTOGRAM);
   SetIndexStyle(5, DRAW_HISTOGRAM);

   return(0);
}

int start()
{
   int toCount = Bars - IndicatorCounted();
   
   for (int i = toCount - 1; i >= 0; i--)
   {
      double hi = iCustom(Symbol(), 0, "Devolatile", ATRPeriod, SmoothPeriod, coef, 0, i);
      double lo = iCustom(Symbol(), 0, "Devolatile", ATRPeriod, SmoothPeriod, coef, 1, i);
      double op = iCustom(Symbol(), 0, "Devolatile", ATRPeriod, SmoothPeriod, coef, 2, i);
      double cl = iCustom(Symbol(), 0, "Devolatile", ATRPeriod, SmoothPeriod, coef, 3, i);
      
      if (hi == EMPTY_VALUE)
      {
         BodyUp[i] = EMPTY_VALUE;
         BodyDown[i] = EMPTY_VALUE;
         MaskBody[i] = EMPTY_VALUE;
         ShadeUp[i] = EMPTY_VALUE;
         ShadeDown[i] = EMPTY_VALUE;
         MaskShade[i] = EMPTY_VALUE;
      }
      else
      {
         if (op > cl)
         {
            BodyDown[i] = op;
            MaskBody[i] = cl;
            ShadeDown[i] = hi;
            MaskShade[i] = lo;

            BodyUp[i] = EMPTY_VALUE;
            ShadeUp[i] = EMPTY_VALUE;
         }
         else
         {
            BodyUp[i] = cl;
            MaskBody[i] = op;
            ShadeUp[i] = hi;
            MaskShade[i] = lo;

            BodyDown[i] = EMPTY_VALUE;
            ShadeDown[i] = EMPTY_VALUE;
         }
      }
   }
}

